import React, { useState, useEffect, useMemo, useCallback } from 'react';
import { Steps } from 'antd';
import ZdyTable from '@/webPublic/one_stop_public/Table';

const { Step } = Steps;

export default function StepDiy(props) {
  const { value, json, partFormProps, dataColumn, onChange } = props;
  const diyProps = useMemo(() => {
    let b = {};
    if (value && typeof value === 'object') {
      b = {
        ...value,
      };
      delete b.formValues;
    }
    if (json.otherProps && typeof json.otherProps === 'string') {
      try {
        let a = new Function(json.otherProps)();
        if (a) {
          return {
            ...a,
            ...b,
          };
        }
        return b;
      } catch (e) {
        console.error('Step组件 otherProps错误');
      }
    } else {
      return b;
    }
  }, [json.otherProps, value]);

  const [current, setCurrent] = useState(diyProps?.StepsProps?.current || 0);
  const [formValues, setFormValues] = useState({});

  const partFormKey = useMemo(() => {
    if (typeof current !== 'undefined') {
      let item = diyProps.Step.find((g, index) => {
        return index === current;
      });
      if (item) {
        return item.formKey;
      }
      partFormProps.form.setFieldsValue(formValues);
    }
    return undefined;
  }, [current]);

  useEffect(() => {
    if (diyProps?.StepsProps?.current !== current) {
      const oldValues = partFormProps.form.getFieldsValue();
      let newV = {
        ...oldValues,
      };
      delete newV[dataColumn.base52];
      setFormValues({
        ...formValues,
        ...newV,
      });
    }
    setCurrent(diyProps?.StepsProps?.current);
  }, [diyProps?.StepsProps?.current]);

  useEffect(() => {
    onChange({
      ...value,
      formValues,
    })
  }, [formValues]);

  console.log(value);

  return (
    <div style={diyProps.outSideDivStyle}>
      <Steps {...diyProps.StepsProps}
             current={current}>
        {Array.isArray(diyProps.Step) &&
          diyProps.Step.map(g => {
            return <Step {...g} key={g.title} />;
          })}
      </Steps>
      {!!partFormKey && (
        <div>
          <ZdyTable
            {...partFormProps}
            currentFormTitle={'Steps组件的子表单' + partFormKey}
            key={partFormKey}
            currentFormKey={partFormKey}
            {...partFormProps?.datas[partFormKey]}
          />
        </div>
      )}
    </div>
  );
}
